digiKam Developer Documentation: Digikam::TableViewColumn Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Types | Signals | Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
Digikam::TableViewColumn Class Referenceabstract
Inheritance diagram for Digikam::TableViewColumn:

## Public Types
enum | ColumnCompareResult { CmpEqual = 0 , CmpABiggerB = 1 , CmpALessB = 2 }
enum | ColumnFlag { ColumnNoFlags = 0 , ColumnCustomPainting = 1 , ColumnCustomSorting = 2 , ColumnHasConfigurationWidget = 4 }
typedef QFlags< ColumnFlag > | ColumnFlags

## Signals
void | signalAllDataChanged ()
void | signalDataChanged (const qlonglong imageId)

## Public Member Functions
| TableViewColumn (TableViewShared *const tableViewShared, const TableViewColumnConfiguration &pConfiguration, QObject *const parent=nullptr)
virtual bool | columnAffectedByChangeset (const ImageChangeset &imageChangeset) const
virtual ColumnCompareResult | compare (TableViewModel::Item *const itemA, TableViewModel::Item *const itemB) const
| This function should never be called, because subclasses have to do the comparison on their own.
virtual QVariant | data (TableViewModel::Item *const item, const int role) const
virtual ColumnFlags | getColumnFlags () const
virtual TableViewColumnConfiguration | getConfiguration () const
virtual TableViewColumnConfigurationWidget * | getConfigurationWidget (QWidget *const parentWidget) const
virtual QString | getTitle () const =0
virtual bool | paint (QPainter *const painter, const QStyleOptionViewItem &option, TableViewModel::Item *const item) const
virtual void | setConfiguration (const TableViewColumnConfiguration &newConfiguration)
virtual QSize | sizeHint (const QStyleOptionViewItem &option, TableViewModel::Item *const item) const
virtual void | updateThumbnailSize ()

## Static Public Member Functions
template<class MyType >
static ColumnCompareResult | compareHelper (const MyType &A, const MyType &B)
static bool | compareHelperBoolFailCheck (const bool okA, const bool okB, ColumnCompareResult *const result)
template<typename columnClass >
static bool | CreateFromConfiguration (TableViewShared *const tableViewShared, const TableViewColumnConfiguration &pConfiguration, TableViewColumn **const pNewColumn, QObject *const parent)
template<typename columnClass >
static bool | getSubColumnIndex (const QString &subColumnId, typename columnClass::SubColumn *const subColumn)

## Protected Attributes
TableViewColumnConfiguration | configuration
TableViewShared *const | s = nullptr

## Member Function Documentation

## ◆ columnAffectedByChangeset()

bool Digikam::TableViewColumn::columnAffectedByChangeset | ( | const ImageChangeset & | imageChangeset | ) | const
| virtual

Reimplemented in Digikam::TableViewColumns::ColumnDigikamProperties.

## ◆ compare()

TableViewColumn::ColumnCompareResult Digikam::TableViewColumn::compare | ( | TableViewModel::Item *const | itemA,
|  | TableViewModel::Item *const | itemB
| ) |  | const
| virtual

But it can not be pure, since then every subclass which does not do custom comparison would have to implement an empty stub.

Reimplemented in Digikam::TableViewColumns::ColumnAudioVideoProperties, Digikam::TableViewColumns::ColumnDigikamProperties, Digikam::TableViewColumns::ColumnFileProperties, Digikam::TableViewColumns::ColumnGeoProperties, Digikam::TableViewColumns::ColumnItemProperties, and Digikam::TableViewColumns::ColumnPhotoProperties.

## ◆ data()

QVariant Digikam::TableViewColumn::data | ( | TableViewModel::Item *const | item,
|  | const int | role
| ) |  | const
| virtual

Reimplemented in Digikam::TableViewColumns::ColumnDigikamProperties, Digikam::TableViewColumns::ColumnFileProperties, Digikam::TableViewColumns::ColumnGeoProperties, Digikam::TableViewColumns::ColumnItemProperties, and Digikam::TableViewColumns::ColumnPhotoProperties.

## ◆ getColumnFlags()

TableViewColumn::ColumnFlags Digikam::TableViewColumn::getColumnFlags | ( |  | ) | const
| virtual

Reimplemented in Digikam::TableViewColumns::ColumnAudioVideoProperties.

## ◆ paint()

bool Digikam::TableViewColumn::paint | ( | QPainter *const | painter,
|  | const QStyleOptionViewItem & | option,
|  | TableViewModel::Item *const | item
| ) |  | const
| virtual

Reimplemented in Digikam::TableViewColumns::ColumnThumbnail.

## ◆ sizeHint()

QSize Digikam::TableViewColumn::sizeHint | ( | const QStyleOptionViewItem & | option,
|  | TableViewModel::Item *const | item
| ) |  | const
| virtual

Reimplemented in Digikam::TableViewColumns::ColumnThumbnail.

## ◆ updateThumbnailSize()

void Digikam::TableViewColumn::updateThumbnailSize | ( |  | ) |
| virtual

Reimplemented in Digikam::TableViewColumns::ColumnThumbnail.